SystemOrganization addCategory: #DevPacerCommon!

Object subclass: #DevPacer
	instanceVariableNames: 'dueTime runningAni intervalMinutes pacerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:08'!
countDownString

	^(self dueTime - DateAndTime now) printString copyFrom:6 to: 10.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:38'!
defaultRunningAni

	^EndlessAni new
		stepTime: 500;
		operation: (MessageSend receiver: self selector: #myOperation).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:50'!
disable

	runningAni isNil ifFalse: [ runningAni stopStepping. runningAni := nil. ].! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
dueTime
	^ dueTime! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:48'!
dueTime: aDateTime
	dueTime := aDateTime! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:07'!
dueTimeHasExpired

	^self dueTime < (DateAndTime now).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:05'!
dueTimeIsNotSet

	^self dueTime isNil.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:39'!
enable

	^self runningAni startStepping.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
intervalMinutes
	^ intervalMinutes! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:48'!
intervalMinutes: aNumber
	intervalMinutes := aNumber! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:43'!
isEnabled

	^self runningAni isStepping.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:48'!
isRunning

	^self runningAni notNil and: [self runningAni isStepping].! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
messageString

	^self stateObject message value.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:27'!
myOperation

	pacerClass myOperation.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 11:24'!
pacerClass: unitPacerClass

	pacerClass := unitPacerClass.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni

	^runningAni setDefault: #defaultRunningAni for: self withSetter: #runningAni: .! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni: anAni

	runningAni := anAni.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:30'!
stateColor
	^self stateObject color.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:38'!
stateObject

	self isEnabled ifFalse: [^ISPState color: Color gray message: ['off']].
	^ISPState color: Color green message: ['well done!!'].! !

Object subclass: #ISPState
	instanceVariableNames: 'message color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ISPState classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2012 17:34'!
color: aColor message: aString

	^self new
		color: aColor;
		message: aString  ! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:54'!
color

	^ color! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
color: aColor
	color := aColor! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message
	^ message! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message: aString
	message := aString! !

Object subclass: #UnitPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

UnitPacer class
	instanceVariableNames: 'Pacer'!

UnitPacer class
	instanceVariableNames: 'Pacer'!

UnitPacer subclass: #CommitPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:08'!
buttonAction

	MCWorkingCopyBrowser open.! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:00'!
buttonHelpString

	^'open Monticello Browser'! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:02'!
buttonLabelString

	^'open'! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
defaultIntervalMinutes
	^ 15! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:15'!
grayState

	^ISPState color: Color gray message: ['watching monticello is off'].! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:11'!
greenState

	^ISPState color: Color green message: ['All packages are clean.']! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:06'!
helpName

	^'commit pacer'! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:05'!
redState

	^ISPState color: Color red message: ['COMMIT NOW!!!!'].    ! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Commit pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #CommitPacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(2 5 10 15 30);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:19'!
somePackageIsDirty

	^MCWorkingCopy allManagers anySatisfy: [:wc| wc needsSaving ]  ! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 5/17/2012 11:30'!
state

	self isRunning not ifTrue: [^self grayState].
	self somePackageIsDirty not ifTrue: [
		self pacer dueTime: nil.
		^self greenState
		].
	self pacer dueTimeIsNotSet ifTrue: [ 
		self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes).
		^self yellowState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Commit after ', self countDownString].! !

UnitPacer subclass: #ImageSavePacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:04'!
buttonAction

	SmalltalkImage current saveAsNewVersion.! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:10'!
buttonHelpString

	^'Save new image version'! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 18:58'!
buttonLabelString

	^'save'! !

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
defaultIntervalMinutes
	^ 2! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:16'!
grayState

	^ISPState color: Color gray message: ['image monitoring is off'].! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:13'!
greenState

	^ISPState color: Color green message: ['No need to save image.'].    
! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'image pacer'! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:12'!
redState

	^ISPState color: Color red message: ['SAVE NEW IMAGE NOW!!'].    ! !

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Image save pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #ImageSavePacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 5/17/2012 11:08'!
state

	self isRunning not ifTrue: [^self grayState].
	self pacer dueTimeIsNotSet ifTrue: [ ^self greenState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 11:04'!
systemChanged
	
	self pacer dueTimeIsNotSet
		ifTrue: [self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes)]
	! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 09:32'!
systemSaved

	self pacer dueTime: nil.
	self changed: #statusColor.
	self changed: #getStatusText.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should save image after ', self countDownString].! !

UnitPacer subclass: #TestPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:09'!
buttonAction

	TestRunner open.! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:01'!
buttonHelpString

	^'open TestRunner'! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:00'!
buttonLabelString

	^'open'! !

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 09:32'!
colorOfTestRunnerGotGreen

	self pacer dueTime: nil.! !

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 11:08'!
colorOfTestRunnerGotNotGreen

	self pacer dueTimeIsNotSet
		ifTrue: [self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes)]! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
defaultIntervalMinutes
	^ 3! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:16'!
grayState

	^ISPState color: Color gray message: ['TestRunner monitoring is off'].! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:38'!
greenState

	^ISPState color: Color green message: ['Test Pass'].    
! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'test pacer'! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:40'!
redState

	^ISPState color: Color red message: ['DO ANYTHING TO MAKE IT GREEN!!'].    ! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Test pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #TestPacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 5/17/2012 11:07'!
state

	self isRunning not ifTrue: [^self grayState].
	self pacer dueTimeIsNotSet ifTrue: [ ^self greenState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should pass after ', self countDownString].! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:52'!
countDownString

	^self pacer countDownString.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:52'!
getStatusText

	^self state message value! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
getStatusTextIsEnabled

	^true! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 5/17/2012 09:25'!
intervalMinutes
	self pacer intervalMinutes isNil
		ifTrue: [ self pacer intervalMinutes: self defaultIntervalMinutes ].
	^self pacer intervalMinutes! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 5/17/2012 09:25'!
intervalMinutes: anInteger

	self intervalMinutes: anInteger.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 10:48'!
isRunning

	^self pacer isRunning.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:14'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'open AutoImageSave Morph')
		parent: #Tools;
		order: 4;
		icon: self taskbarIcon;
		label: 'DevPacer';
		action: [ 
			| imageSavePanel commitPanel testPanel win |
			imageSavePanel := ImageSavePacer morphPanel.
			commitPanel := CommitPacer morphPanel.
			testPanel := TestPacer morphPanel.
			win := (UITheme builder newColumn: {imageSavePanel. commitPanel. testPanel}) openInWindowLabeled: 'DevPacer'.
			win extent:   (319@152).
			win model: self ]! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 18:58'!
morphPanel
	| statusText builder colorBar checkbox button |
	builder := UITheme builder.
	colorBar := builder newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	statusText := builder newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	button := builder newButtonFor: self action: #buttonAction getEnabled: nil label: self buttonLabelString help: self buttonHelpString.
	checkbox := builder
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ builder newGroupboxForAll: {builder newRow: {checkbox. builder newStack:{statusText . colorBar}. button}}.
! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 3/31/2012 14:54'!
myOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:26'!
pacer

	Pacer isNil ifTrue: 
		[
			Pacer := DevPacer new.
			Pacer pacerClass: self.
		].
	^Pacer.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 09:27'!
run

	self pacer enable.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
shouldCheckboxEnabled

	^true! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
statusColor

	^self state color.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 10:50'!
stop

	self pacer disable.
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 09:28'!
strongStop

	self stop.
	self pacer runningAni: nil.! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2012 20:05'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:15'!
userStyleOn: aBuilder 
	<systemsettings>
	(aBuilder group: #DevPacer) label: 'DevPacer' translated! !

TestCase subclass: #DevPacerTest
	instanceVariableNames: 'pacer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:28'!
setUp

	super setUp.
	pacer := DevPacer new.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:41'!
tearDown

	pacer disable.
	super tearDown.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
testDisabledAtFirst

	self deny: pacer isEnabled.
	self assert: Color gray equals: pacer stateColor.
	self assert: 'off' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:40'!
testEnable

	pacer enable.
	self assert: pacer isEnabled.
	self assert: Color green equals: pacer stateColor.
	self assert: 'well done!!' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 09:51'!
testFail

	"self fail."! !
